//+------------------------------------------------------------------+
//|                                                       Nick 2.mq4 |
//|                                    Copyright  2010, Nick Masman |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Nick Masman"

//make whole program execute every bar. 
//change indicators shift backwards 1.
//try adding a second slope ema.


//Trade Externs
extern int TrailBy = 30;
bool BarsStopLoss = true;
extern int StopLossBars = 10;
extern int BarsStopExtend = 15;
extern bool TrailStopLoss = true;
extern bool TrailAfterBreakeven = true;
extern bool UseTakeProfit = false;
extern int TakeProfitSize = 60;
extern bool UseDynamicLotSize = true;
extern double MaxRiskPercent = 2;
extern double FixedLotSize = 0.1;
extern int EntryBars = 3;
extern int EntryPipsExtend = 5;

double LotSize = 0.1;

//Large Trend Externs
extern int FastEMAPeriod = 40;
extern int SlowEMAPeriod = 60;
extern int SlopeEMAPeriod = 20;
extern bool UseDivergence = true;
extern bool UseSlopeEMA = true;
extern int StochOB = 80;
extern int StochOS = 20;
extern int KPeriod = 12;
extern int StochSlowing = 6;

datetime LastRunTime;

//Multipliers
extern int TrendPeriodMultiplier = 4;
extern int PullbackPeriodMultiplier = 1;

int MagicNumber = 1337;
int Slippage = 5;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//run once at the start of each bar:
if(LastRunTime != iTime(NULL,0,0))
{
  
  
  
int StopLossSize = TrailBy;
  
int CalcDigits = MarketInfo(Symbol(),MODE_DIGITS);
double PipSize = 0.0001;
if(CalcDigits == 2 || CalcDigits == 3) 
   {
      PipSize = 0.01;
   }
else if(CalcDigits == 4 || CalcDigits == 5)
   {
      PipSize = 0.0001;
   }

   
double StopLossUse = StopLossSize * PipSize;
NormalizeDouble(StopLossUse, CalcDigits);
double TakeProfitUse = TakeProfitSize * PipSize;
NormalizeDouble(TakeProfitUse, CalcDigits);

//----
//TREND INDICATORS
RefreshRates();
double FastEMACurrent = iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
double FastEMAPrevious = iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,2);
   
double SlowEMACurrent = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
double SlowEMAPrevious = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,2);
   
double SlopeEMACurrent = iMA(NULL,0,(SlopeEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
double SlopeEMAPrevious = iMA(NULL,0,(SlopeEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,2);
   
double CurrentEMASpread = MathAbs(FastEMACurrent-SlowEMACurrent);
double PreviousEMASpread = MathAbs(FastEMAPrevious-SlowEMAPrevious);

     
//CHECK TO SEE IF FAST/SLOW EMAS ARE DIVERGING
bool Divergence = false;
   if(CurrentEMASpread > PreviousEMASpread)
      {
        Divergence = true;
      }
      else Divergence=false;
      
//SETTING PULLBACK VARIABLE. DO NOT COMBINE WITH TREND VARIABLE.

int Stochastic = iStochastic(NULL, 0, (KPeriod*PullbackPeriodMultiplier), 3, (StochSlowing*PullbackPeriodMultiplier), MODE_EMA, 1, 0, 1);
int StochasticPrev = iStochastic(NULL, 0, (KPeriod*PullbackPeriodMultiplier), 3, (StochSlowing*PullbackPeriodMultiplier), MODE_EMA, 1, 0, 2);

int Pullback = 0;
if(Stochastic > StochOB)
   {
      Pullback = -1;
   }

else if(Stochastic < StochOS)
   {
      Pullback = 1;
   }
else Pullback = 0;

//SETTING THE TREND VARIABLE BASED ON EMA CONDITIONS.
int Trend = 0;
      if((FastEMACurrent > SlowEMACurrent) && (Divergence == true || UseDivergence == false) && ((SlopeEMACurrent > SlopeEMAPrevious) || UseSlopeEMA == false))
         {
            Trend = 1;
            ObjectDelete("TrendUpArrow");
            ObjectCreate("TrendUpArrow", OBJ_ARROW, 0, iTime(NULL, 0, 0), Ask);
            ObjectSet("TrendUpArrow", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
         }
      else if((FastEMACurrent < SlowEMACurrent) && (Divergence == true || UseDivergence == false) && ((SlopeEMACurrent < SlopeEMAPrevious) || UseSlopeEMA == false))
         {
            Trend = -1;
            ObjectDelete("TrendDownArrow");
            ObjectCreate("TrendDownArrow", OBJ_ARROW, 0, iTime(NULL, 0, 0), Ask);
            ObjectSet("TrendDownArrow", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
         }
      else
         {
            Trend = 0;
            ObjectDelete("TrendFlatArrow");
            ObjectCreate("TrendFlatArrow", OBJ_ARROW, 0, iTime(NULL, 0, 0), Ask);
            ObjectSet("TrendFlatArrow", OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
         }
int OrderCounter = 0;

   for(int Counter = 0; Counter <= OrdersTotal()-1; Counter++)
      {
         bool SelectOrder = OrderSelect(Counter,SELECT_BY_POS);
         if((OrderMagicNumber() == MagicNumber) && (OrderType() == OP_BUYSTOP) && (Trend != 1))
            {
               OrderDelete(OrderTicket());
            }
         if((OrderMagicNumber() == MagicNumber) && (OrderType() == OP_SELLSTOP) && (Trend != -1))
            {
               OrderDelete(OrderTicket());
            }
      }

//COUNT ALL ORDERS TO HAVE ONLY 1 OPEN AT A TIME
double TotalOrderProfit = 0;
   for(Counter = 0; Counter <= OrdersTotal()-1; Counter++)
      {
         SelectOrder = OrderSelect(Counter,SELECT_BY_POS);
         //using LongtEntryCalc to calculate new lot sizes for order modification. Entry only moves towards price.
         if((OrderMagicNumber() == MagicNumber) && ((OrderType() == OP_SELLSTOP) || (OrderType() == OP_BUYSTOP)))
            {
               OrderCounter++;
            }
         if((OrderMagicNumber() == MagicNumber) && ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)))
            {
               TotalOrderProfit += OrderProfit();
            }
      }
      
int ShortStopLossShift = iHighest(NULL,0,MODE_HIGH,StopLossBars,0);      
int LongStopLossShift = iLowest(NULL,0,MODE_LOW,StopLossBars,0);     
 
//CALCULATE LOT SIZE
RefreshRates();

double MaxRiskDollars = AccountEquity() * (MaxRiskPercent/100);
double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
if(Digits == 3 || Digits == 5) TickValue *= 10;

double LongRiskPips = ((BarsStopExtend) + ((Ask - Low[LongStopLossShift])/PipSize));
double LongLotSize = (MaxRiskDollars / LongRiskPips) / TickValue;
double ShortRiskPips = ((BarsStopExtend) + ((Bid + High[ShortStopLossShift])/PipSize));
double ShortLotSize = (MaxRiskDollars / ShortRiskPips) / TickValue;

if(UseDynamicLotSize == false)
   {
      LongLotSize = FixedLotSize;
      ShortLotSize = FixedLotSize;
   }
else if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
   {  
      LongLotSize = NormalizeDouble(LongLotSize,1);
      ShortLotSize = NormalizeDouble(ShortLotSize,1);
   }
else
   {
      LongLotSize = NormalizeDouble(LongLotSize,2);
      ShortLotSize = NormalizeDouble(ShortLotSize,2);
   }
   
if(LongLotSize < MarketInfo(Symbol(), MODE_MINLOT))
   {  
      LongLotSize = MarketInfo(Symbol(), MODE_MINLOT);
   }
if(ShortLotSize < MarketInfo(Symbol(), MODE_MINLOT))
   {  
      ShortLotSize = MarketInfo(Symbol(), MODE_MINLOT);
   }
   
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//BUY AND SELL ORDERS
int LongEntryShift = iHighest(NULL,0,MODE_HIGH,EntryBars,0);
int ShortEntryShift = iLowest(NULL,0,MODE_LOW,EntryBars,0);

double LongEntryLevel = High[LongEntryShift] + (EntryPipsExtend * PipSize);
double ShortEntryLevel = Low[ShortEntryShift] - (EntryPipsExtend * PipSize);
NormalizeDouble(LongEntryLevel, CalcDigits);
NormalizeDouble(ShortEntryLevel, CalcDigits);


   if((OrderCounter == 0) && (LotSize != 0))
      {
         if((Trend == 1) && (Pullback == 1) && (TotalOrderProfit >= 0))
            {
               RefreshRates();
               if(BarsStopLoss == true)
                  {
                     double LongStopLossLevel = Low[LongStopLossShift] - (BarsStopExtend * PipSize);
                     NormalizeDouble(LongStopLossLevel, CalcDigits);
                  }
               else LongStopLossLevel = NormalizeDouble((Ask - StopLossUse), CalcDigits);
               
               if(UseTakeProfit == false)
                  { 
                     double LongTakeProfitLevel = 0;
                  }
               else LongTakeProfitLevel = NormalizeDouble((Ask + TakeProfitUse), CalcDigits);
               
               int BuyTicket = OrderSend(Symbol(),OP_BUYSTOP,LongLotSize,LongEntryLevel,Slippage,LongStopLossLevel,LongTakeProfitLevel,"Buy Stop Order",MagicNumber,0,Green);
               Print("Attempted Buy Stop Order, Ticket: ",BuyTicket,"Entry Level: ",LongEntryLevel,". StopLoss: ",LongStopLossLevel,". Ask: ",Ask,". TakeProfit: ",LongTakeProfitLevel,". LongLotSize: ",LongLotSize);
            }
         if((Trend == -1) && (Pullback == -1) && (TotalOrderProfit >= 0))
            {
               RefreshRates();
               if(BarsStopLoss == true)
                  {
                     double ShortStopLossLevel = High[LongStopLossShift] + (BarsStopExtend * PipSize);
                     NormalizeDouble(ShortStopLossLevel, CalcDigits);
                  }
               else ShortStopLossLevel = NormalizeDouble((Bid + StopLossUse), CalcDigits);
               
               if(UseTakeProfit == false)
                  { 
                     double ShortTakeProfitLevel = 0;
                  }
               else ShortTakeProfitLevel = NormalizeDouble((Bid - TakeProfitUse), CalcDigits);
               
               int SellTicket = OrderSend(Symbol(),OP_SELLSTOP,ShortLotSize,ShortEntryLevel,Slippage,ShortStopLossLevel,ShortTakeProfitLevel,"Sell Order",MagicNumber,0,Green);
               Print("Attempted Sell Stop Order, Ticket: ",BuyTicket,"Entry Level: ",ShortEntryLevel,". StopLoss: ",ShortStopLossLevel,". Ask: ",Ask,". TakeProfit: ",ShortTakeProfitLevel,". ShortLotSize: ",ShortLotSize);
            }
      }
      
//MODIFY PENDING ORDER STUFF
for(Counter = 0; Counter <= OrdersTotal()-1; Counter++)
   {
      OrderSelect(Counter, SELECT_BY_POS);
      //modify buystops if new entry level is closer to price
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUYSTOP && LongEntryLevel < OrderOpenPrice())
         {
            bool BuyStopModified = OrderModify(OrderTicket(),LongEntryLevel,LongStopLossLevel,OrderTakeProfit(),0);
            Print("Attempting BUYSTOP Mod. Ticket: ",OrderTicket(),". Long Entry Level: ",LongEntryLevel,". Ask: ",Ask);
         }
      //modify sellstops if new entry level is closer to price
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELLSTOP && ShortEntryLevel > OrderOpenPrice())
         {
            bool SellStopModified = OrderModify(OrderTicket(),LongEntryLevel,ShortStopLossLevel,OrderTakeProfit(),0);
            Print("Attempting SELLSTOP Mod. Ticket: ",OrderTicket(),". Short Entry Level: ",ShortEntryLevel,". Bid: ",Bid);
         }
   }
   
   
//TRAIL THE STOP LOSS
for(Counter = 0; Counter <= OrdersTotal()-1; Counter++)
   { 
      OrderSelect(Counter, SELECT_BY_POS);
      
      double MaxLongStopLoss = MarketInfo(Symbol(),MODE_BID) - StopLossUse;
      double MaxShortStopLoss = MarketInfo(Symbol(),MODE_ASK) + StopLossUse;
      
      MaxShortStopLoss = NormalizeDouble(MaxShortStopLoss, CalcDigits);
      MaxLongStopLoss = NormalizeDouble(MaxLongStopLoss, CalcDigits);
      
      double CurrentStop = NormalizeDouble(OrderStopLoss(), CalcDigits);
      
      //Modify Stops
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY && CurrentStop < MaxLongStopLoss && TrailStopLoss == true && (TrailAfterBreakeven == false || OrderOpenPrice() < MaxLongStopLoss))
         {
            bool LongTrailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxLongStopLoss,OrderTakeProfit(),0);
         }
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL && CurrentStop > MaxShortStopLoss && TrailStopLoss == true && (TrailAfterBreakeven == false || OrderOpenPrice() > MaxShortStopLoss))
         {
            bool ShortTrailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxShortStopLoss,OrderTakeProfit(),0);
         }

   }




LastRunTime = iTime(NULL,0,0);
}//End bracket for running once per bar.
//END OF THE PROGRAM



//----
   return(0);
  }
//+------------------------------------------------------------------+